blob: 77e9a60fcbc1237beca44c39ed5d045b116b0fd3 [file] [log] [blame]
Jonathan Niederc74c7202013-11-25 13:03:06 -08001# Test framework for git. See t/README for usage.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07002#
3# Copyright (c) 2005 Junio C Hamano
4#
Michal Sojka64b90322010-04-16 15:53:59 +02005# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070017
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070018# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
Felipe Contreras85176d72013-11-17 23:12:43 -050026else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070030fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
Jeff Kingd0cc5792017-07-10 09:24:35 -040039# If we were built with ASAN, it may complain about leaks
40# of program-lifetime variables. Disable it by default to lower
41# the noise level. This needs to happen at the start of the script,
42# before we even do our "did we build git yet" check (since we don't
43# want that one to complain to stderr).
Jeff Kingbf1ce902017-07-10 09:24:39 -040044: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
Jeff Kingd0cc5792017-07-10 09:24:35 -040045export ASAN_OPTIONS
46
Jeff King85b81b32017-09-05 09:04:04 -040047# If LSAN is in effect we _do_ want leak checking, but we still
48# want to abort so that we notice the problems.
49: ${LSAN_OPTIONS=abort_on_error=1}
50export LSAN_OPTIONS
51
Johannes Schindelin8abfdf42018-11-14 08:32:11 -080052if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
Ramkumar Ramachandra2006f0a2012-09-17 22:36:19 +053053then
Johannes Schindelin8abfdf42018-11-14 08:32:11 -080054 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
Ramkumar Ramachandra2006f0a2012-09-17 22:36:19 +053055 exit 1
56fi
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070057. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58export PERL_PATH SHELL_PATH
59
Johannes Schindelinb02e7d52019-04-12 02:37:24 -070060# Disallow the use of abbreviated options in the test suite by default
61if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
62then
63 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
64 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
65fi
66
Junio C Hamanoc2116a12008-03-06 19:04:26 -080067################################################################
68# It appears that people try to run tests without building...
Johannes Schindelin8abfdf42018-11-14 08:32:11 -080069"${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070070if test $? != 1
71then
Johannes Schindelined306e42018-11-14 08:32:10 -080072 if test -n "$GIT_TEST_INSTALLED"
73 then
74 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
75 else
76 echo >&2 'error: you do not seem to have built git yet.'
77 fi
Pavel Roskind9bdd392005-08-10 22:10:01 -040078 exit 1
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070079fi
Junio C Hamanoc2116a12008-03-06 19:04:26 -080080
SZEDER Gábor8cf58002019-01-05 02:08:55 +010081store_arg_to=
Matheus Tavares78dc0882020-03-22 12:58:57 -030082opt_required_arg=
83# $1: option string
84# $2: name of the var where the arg will be stored
85mark_option_requires_arg () {
86 if test -n "$opt_required_arg"
SZEDER Gábor8cf58002019-01-05 02:08:55 +010087 then
Matheus Tavares78dc0882020-03-22 12:58:57 -030088 echo "error: options that require args cannot be bundled" \
89 "together: '$opt_required_arg' and '$1'" >&2
90 exit 1
SZEDER Gábor8cf58002019-01-05 02:08:55 +010091 fi
Matheus Tavares78dc0882020-03-22 12:58:57 -030092 opt_required_arg=$1
93 store_arg_to=$2
94}
95
96parse_option () {
97 local opt="$1"
SZEDER Gábor8cf58002019-01-05 02:08:55 +010098
99 case "$opt" in
100 -d|--d|--de|--deb|--debu|--debug)
101 debug=t ;;
102 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
103 immediate=t ;;
104 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
105 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
106 -r)
Matheus Tavares78dc0882020-03-22 12:58:57 -0300107 mark_option_requires_arg "$opt" run_list
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100108 ;;
109 --run=*)
110 run_list=${opt#--*=} ;;
111 -h|--h|--he|--hel|--help)
112 help=t ;;
113 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
114 verbose=t ;;
115 --verbose-only=*)
116 verbose_only=${opt#--*=}
117 ;;
118 -q|--q|--qu|--qui|--quie|--quiet)
119 # Ignore --quiet under a TAP::Harness. Saying how many tests
120 # passed without the ok/not ok details is always an error.
121 test -z "$HARNESS_ACTIVE" && quiet=t ;;
122 --with-dashes)
123 with_dashes=t ;;
Johannes Schindelindd167a32019-01-29 06:19:37 -0800124 --no-bin-wrappers)
125 no_bin_wrappers=t ;;
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100126 --no-color)
127 color= ;;
128 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
129 valgrind=memcheck
130 tee=t
131 ;;
132 --valgrind=*)
133 valgrind=${opt#--*=}
134 tee=t
135 ;;
136 --valgrind-only=*)
137 valgrind_only=${opt#--*=}
138 tee=t
139 ;;
140 --tee)
141 tee=t ;;
142 --root=*)
143 root=${opt#--*=} ;;
144 --chain-lint)
145 GIT_TEST_CHAIN_LINT=1 ;;
146 --no-chain-lint)
147 GIT_TEST_CHAIN_LINT=0 ;;
148 -x)
149 trace=t ;;
150 -V|--verbose-log)
151 verbose_log=t
152 tee=t
153 ;;
Johannes Schindelin22231902019-01-29 06:19:27 -0800154 --write-junit-xml)
155 write_junit_xml=t
156 ;;
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100157 --stress)
158 stress=t ;;
159 --stress=*)
Johannes Schindelinf5457372019-03-03 06:44:55 -0800160 echo "error: --stress does not accept an argument: '$opt'" >&2
161 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
162 exit 1
163 ;;
164 --stress-jobs=*)
165 stress=t;
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100166 stress=${opt#--*=}
167 case "$stress" in
SZEDER Gábor7d661e52019-02-11 20:58:03 +0100168 *[!0-9]*|0*|"")
Johannes Schindelinf5457372019-03-03 06:44:55 -0800169 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100170 exit 1
171 ;;
172 *) # Good.
173 ;;
174 esac
175 ;;
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100176 --stress-limit=*)
Johannes Schindelinde69e6f2019-03-03 06:44:54 -0800177 stress=t;
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100178 stress_limit=${opt#--*=}
179 case "$stress_limit" in
SZEDER Gábor7d661e52019-02-11 20:58:03 +0100180 *[!0-9]*|0*|"")
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100181 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
182 exit 1
183 ;;
184 *) # Good.
185 ;;
186 esac
187 ;;
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100188 *)
189 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
190 esac
Matheus Tavares78dc0882020-03-22 12:58:57 -0300191}
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100192
Matheus Tavares78dc0882020-03-22 12:58:57 -0300193# Parse options while taking care to leave $@ intact, so we will still
194# have all the original command line options when executing the test
195# script again for '--tee' and '--verbose-log' later.
196for opt
197do
198 if test -n "$store_arg_to"
199 then
200 eval $store_arg_to=\$opt
201 store_arg_to=
202 opt_required_arg=
203 continue
204 fi
205
206 case "$opt" in
207 --*|-?)
208 parse_option "$opt" ;;
209 -?*)
210 # bundled short options must be fed separately to parse_option
211 opt=${opt#-}
212 while test -n "$opt"
213 do
214 extra=${opt#?}
215 this=${opt%$extra}
216 opt=$extra
217 parse_option "-$this"
218 done
219 ;;
220 *)
221 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
222 esac
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100223done
224if test -n "$store_arg_to"
225then
Matheus Tavares78dc0882020-03-22 12:58:57 -0300226 echo "error: $opt_required_arg requires an argument" >&2
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100227 exit 1
228fi
229
230if test -n "$valgrind_only"
231then
232 test -z "$valgrind" && valgrind=memcheck
233 test -z "$verbose" && verbose_only="$valgrind_only"
234elif test -n "$valgrind"
235then
236 test -z "$verbose_log" && verbose=t
237fi
238
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100239if test -n "$stress"
240then
241 verbose=t
242 trace=t
243 immediate=t
244fi
245
246TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100247TEST_NAME="$(basename "$0" .sh)"
SZEDER Gáborffe1afe2019-08-05 23:04:47 +0200248TEST_NUMBER="${TEST_NAME%%-*}"
249TEST_NUMBER="${TEST_NUMBER#t}"
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100250TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100251TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
252TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
SZEDER Gábor61f292d2019-01-05 02:08:57 +0100253test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
254case "$TRASH_DIRECTORY" in
255/*) ;; # absolute path is good
256 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
257esac
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100258
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100259# If --stress was passed, run this test repeatedly in several parallel loops.
260if test "$GIT_TEST_STRESS_STARTED" = "done"
261then
262 : # Don't stress test again.
263elif test -n "$stress"
264then
265 if test "$stress" != t
266 then
267 job_count=$stress
268 elif test -n "$GIT_TEST_STRESS_LOAD"
269 then
270 job_count="$GIT_TEST_STRESS_LOAD"
271 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
272 test -n "$job_count"
273 then
274 job_count=$((2 * $job_count))
275 else
276 job_count=8
277 fi
278
279 mkdir -p "$TEST_RESULTS_DIR"
280 stressfail="$TEST_RESULTS_BASE.stress-failed"
281 rm -f "$stressfail"
282
283 stress_exit=0
284 trap '
285 kill $job_pids 2>/dev/null
286 wait
287 stress_exit=1
288 ' TERM INT HUP
289
290 job_pids=
291 job_nr=0
292 while test $job_nr -lt "$job_count"
293 do
294 (
295 GIT_TEST_STRESS_STARTED=done
296 GIT_TEST_STRESS_JOB_NR=$job_nr
297 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
298
299 trap '
300 kill $test_pid 2>/dev/null
301 wait
302 exit 1
303 ' TERM INT
304
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100305 cnt=1
306 while ! test -e "$stressfail" &&
307 { test -z "$stress_limit" ||
308 test $cnt -le $stress_limit ; }
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100309 do
310 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
311 test_pid=$!
312
313 if wait $test_pid
314 then
315 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
316 else
317 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
318 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
319 fi
320 cnt=$(($cnt + 1))
321 done
322 ) &
323 job_pids="$job_pids $!"
324 job_nr=$(($job_nr + 1))
325 done
326
327 wait
328
329 if test -f "$stressfail"
330 then
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100331 stress_exit=1
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100332 echo "Log(s) of failed test run(s):"
333 for failed_job_nr in $(sort -n "$stressfail")
334 do
335 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
336 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
337 done
338 rm -rf "$TRASH_DIRECTORY.stress-failed"
339 # Move the last one.
340 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
341 fi
342
343 exit $stress_exit
344fi
345
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +0530346# if --tee was passed, write the output not only to the terminal, but
347# additionally to the file test-results/$BASENAME.out, too.
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100348if test "$GIT_TEST_TEE_STARTED" = "done"
349then
350 : # do not redirect again
351elif test -n "$tee"
352then
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100353 mkdir -p "$TEST_RESULTS_DIR"
Jeff King452320f2016-10-21 06:48:00 -0400354
355 # Make this filename available to the sub-process in case it is using
356 # --verbose-log.
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100357 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
Jeff King452320f2016-10-21 06:48:00 -0400358 export GIT_TEST_TEE_OUTPUT_FILE
359
360 # Truncate before calling "tee -a" to get rid of the results
361 # from any previous runs.
362 >"$GIT_TEST_TEE_OUTPUT_FILE"
363
Jeff King3f824e92017-12-08 05:47:22 -0500364 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100365 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
366 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +0530367 exit
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100368fi
369
370if test -n "$trace" && test -n "$test_untraceable"
371then
372 # '-x' tracing requested, but this test script can't be reliably
373 # traced, unless it is run with a Bash version supporting
374 # BASH_XTRACEFD (introduced in Bash v4.1).
375 #
376 # Perform this version check _after_ the test script was
377 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
378 # '--verbose-log', so the right shell is checked and the
379 # warning is issued only once.
380 if test -n "$BASH_VERSION" && eval '
381 test ${BASH_VERSINFO[0]} -gt 4 || {
382 test ${BASH_VERSINFO[0]} -eq 4 &&
383 test ${BASH_VERSINFO[1]} -ge 1
384 }
385 '
386 then
387 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
388 else
389 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
390 trace=
391 fi
392fi
393if test -n "$trace" && test -z "$verbose_log"
394then
395 verbose=t
396fi
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +0530397
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700398# For repeatability, reset the environment to known value.
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400399# TERM is sanitized below, after saving color control sequences.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700400LANG=C
401LC_ALL=C
402PAGER=cat
403TZ=UTC
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400404export LANG LC_ALL PAGER TZ
Eric Wong8ff99e72006-07-11 12:01:54 -0700405EDITOR=:
Ævar Arnfjörð Bjarmason6cdccfc2018-11-08 21:15:29 +0000406
407# GIT_TEST_GETTEXT_POISON should not influence git commands executed
408# during initialization of test-lib and the test repo. Back it up,
409# unset and then restore after initialization is finished.
410if test -n "$GIT_TEST_GETTEXT_POISON"
411then
412 GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
413 unset GIT_TEST_GETTEXT_POISON
414fi
415
Stefano Lattarini661bfd12012-03-02 19:48:36 +0100416# A call to "unset" with no arguments causes at least Solaris 10
417# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
418# deriving from the command substitution clustered with the other
419# ones.
Junio C Hamano3c8f12c2012-06-24 22:01:35 -0700420unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
Jonathan Nieder95a1d122011-03-15 05:10:45 -0500421 my @env = keys %ENV;
Jens Lehmann730477f2011-03-28 21:16:09 +0200422 my $ok = join("|", qw(
423 TRACE
424 DEBUG
Jens Lehmann730477f2011-03-28 21:16:09 +0200425 TEST
426 .*_TEST
427 PROVE
428 VALGRIND
René Scharfeac001282013-01-06 18:47:57 +0100429 UNZIP
Nguyễn Thái Ngọc Duyedb54082013-01-15 20:50:56 +0700430 PERF_
Jeff Kinge2a0ccc2014-05-22 05:28:50 -0400431 CURL_VERBOSE
Elia Pinto4527aa12016-09-05 10:24:42 +0000432 TRACE_CURL
Jens Lehmann730477f2011-03-28 21:16:09 +0200433 ));
434 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
Jonathan Nieder95a1d122011-03-15 05:10:45 -0500435 print join("\n", @vars);
436')
Genki Sky7976e902018-02-15 21:46:04 -0500437unset XDG_CACHE_HOME
Jeff King5adf84e2012-07-24 07:53:05 -0400438unset XDG_CONFIG_HOME
Benoit Person8bade1e2013-07-04 22:38:55 +0200439unset GITPERLLIB
Prarit Bhargavad8b82172019-10-29 08:09:14 -0400440TEST_AUTHOR_LOCALNAME=author
441TEST_AUTHOR_DOMAIN=example.com
442GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800443GIT_AUTHOR_NAME='A U Thor'
Prarit Bhargavad8b82172019-10-29 08:09:14 -0400444TEST_COMMITTER_LOCALNAME=committer
445TEST_COMMITTER_DOMAIN=example.com
446GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800447GIT_COMMITTER_NAME='C O Mitter'
Shawn O. Pearce8d0fc482007-02-04 00:45:47 -0500448GIT_MERGE_VERBOSITY=5
Junio C Hamanof8246282012-01-10 22:44:45 -0800449GIT_MERGE_AUTOEDIT=no
450export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800451export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
452export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
Jonathan Niederd33738d2009-11-11 17:56:07 -0600453export EDITOR
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700454
Karsten Blees124647c2014-07-12 02:03:01 +0200455# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
456GIT_TRACE_BARE=1
457export GIT_TRACE_BARE
458
Ben Peart4cb54d02018-09-18 23:29:35 +0000459check_var_migration () {
Junio C Hamano4231d1b2018-09-20 11:43:43 -0700460 # the warnings and hints given from this helper depends
461 # on end-user settings, which will disrupt the self-test
462 # done on the test framework itself.
463 case "$GIT_TEST_FRAMEWORK_SELFTEST" in
464 t) return ;;
465 esac
466
Ben Peart4cb54d02018-09-18 23:29:35 +0000467 old_name=$1 new_name=$2
468 eval "old_isset=\${${old_name}:+isset}"
469 eval "new_isset=\${${new_name}:+isset}"
Junio C Hamano4231d1b2018-09-20 11:43:43 -0700470
Ben Peart4cb54d02018-09-18 23:29:35 +0000471 case "$old_isset,$new_isset" in
472 isset,)
473 echo >&2 "warning: $old_name is now $new_name"
474 echo >&2 "hint: set $new_name too during the transition period"
475 eval "$new_name=\$$old_name"
476 ;;
477 isset,isset)
478 # do this later
479 # echo >&2 "warning: $old_name is now $new_name"
480 # echo >&2 "hint: remove $old_name"
481 ;;
482 esac
483}
484
485check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
Ben Peart1f357b02018-09-18 23:29:36 +0000486check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
Ben Peart5765d972018-09-18 23:29:37 +0000487check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
Ben Peart1f357b02018-09-18 23:29:36 +0000488
489# Use specific version of the index file format
490if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
Thomas Gummerer5d9fc882014-02-23 21:49:58 +0100491then
Ben Peart1f357b02018-09-18 23:29:36 +0000492 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
Thomas Gummerer5d9fc882014-02-23 21:49:58 +0100493 export GIT_INDEX_VERSION
494fi
495
Elia Pintoa731fa92012-09-14 09:54:22 -0700496# Add libc MALLOC and MALLOC_PERTURB test
497# only if we are not executing the test with valgrind
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100498if test -n "$valgrind" ||
René Scharfeee1431b2012-09-26 22:16:39 +0200499 test -n "$TEST_NO_MALLOC_CHECK"
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700500then
501 setup_malloc_check () {
502 : nothing
503 }
504 teardown_malloc_check () {
505 : nothing
506 }
507else
508 setup_malloc_check () {
509 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
510 export MALLOC_CHECK_ MALLOC_PERTURB_
511 }
512 teardown_malloc_check () {
513 unset MALLOC_CHECK_ MALLOC_PERTURB_
514 }
515fi
Elia Pintoa731fa92012-09-14 09:54:22 -0700516
Junio C Hamano886a3902007-04-24 11:21:47 -0700517# Protect ourselves from common misconfiguration to export
518# CDPATH into the environment
519unset CDPATH
520
Bert Wesarg5565f472009-11-18 17:15:19 +0100521unset GREP_OPTIONS
René Scharfeac001282013-01-06 18:47:57 +0100522unset UNZIP
Bert Wesarg5565f472009-11-18 17:15:19 +0100523
Robin Rosenberg3d5c0cc2006-09-23 00:35:20 +0200524case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
Ramsay Jones1c0cc752012-09-01 19:11:49 +01005251|2|true)
Jeff King025232e2015-03-13 00:50:56 -0400526 GIT_TRACE=4
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100527 ;;
Christian Couder6ce4e612006-09-02 18:23:48 +0200528esac
529
Junio C Hamano3f4ab622011-08-08 11:51:00 -0700530# Line feed
531LF='
532'
533
Denton Liubd482d62019-09-05 15:10:05 -0700534# Single quote
535SQ=\'
536
Jeff Kinga42643a2014-12-15 18:15:20 -0500537# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
538# when case-folding filenames
539u200c=$(printf '\342\200\214')
540
brian m. carlsonbd981d52018-05-13 02:24:14 +0000541export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
Thomas Rast342e9ef2012-02-17 11:25:09 +0100542
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700543# Each test should start with something like this, after copyright notices:
544#
545# test_description='Description of this test...
546# This test checks if command xyzzy does the right thing...
547# '
548# . ./test-lib.sh
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400549test "x$TERM" != "xdumb" && (
Richard Hansenca92a662015-06-17 15:06:25 -0400550 test -t 1 &&
551 tput bold >/dev/null 2>&1 &&
552 tput setaf 1 >/dev/null 2>&1 &&
553 tput sgr0 >/dev/null 2>&1
554 ) &&
555 color=t
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700556
Richard Hansenca92a662015-06-17 15:06:25 -0400557if test -n "$color"
558then
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400559 # Save the color control sequences now rather than run tput
560 # each time say_color() is called. This is done for two
561 # reasons:
562 # * TERM will be changed to dumb
563 # * HOME will be changed to a temporary directory and tput
564 # might need to read ~/.terminfo from the original HOME
565 # directory to get the control sequences
566 # Note: This approach assumes the control sequences don't end
567 # in a newline for any terminal of interest (command
568 # substitutions strip trailing newlines). Given that most
569 # (all?) terminals in common use are related to ECMA-48, this
570 # shouldn't be a problem.
571 say_color_error=$(tput bold; tput setaf 1) # bold red
572 say_color_skip=$(tput setaf 4) # blue
573 say_color_warn=$(tput setaf 3) # brown/yellow
574 say_color_pass=$(tput setaf 2) # green
575 say_color_info=$(tput setaf 6) # cyan
576 say_color_reset=$(tput sgr0)
577 say_color_="" # no formatting for normal text
Richard Hansenca92a662015-06-17 15:06:25 -0400578 say_color () {
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400579 test -z "$1" && test -n "$quiet" && return
580 eval "say_color_color=\$say_color_$1"
Richard Hansenca92a662015-06-17 15:06:25 -0400581 shift
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400582 printf "%s\\n" "$say_color_color$*$say_color_reset"
Richard Hansenca92a662015-06-17 15:06:25 -0400583 }
584else
585 say_color() {
586 test -z "$1" && test -n "$quiet" && return
587 shift
588 printf "%s\n" "$*"
589 }
590fi
591
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400592TERM=dumb
593export TERM
594
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200595error () {
596 say_color error "error: $*"
Johannes Schindelinab7d8542019-10-04 08:09:34 -0700597 finalize_junit_xml
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200598 GIT_EXIT_OK=t
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200599 exit 1
600}
601
SZEDER Gábor165293a2018-11-19 14:13:26 +0100602BUG () {
603 error >&7 "bug in the test script: $*"
604}
605
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200606say () {
607 say_color info "$*"
608}
609
Jeff King614fe012016-10-22 00:45:06 -0400610if test -n "$HARNESS_ACTIVE"
611then
612 if test "$verbose" = t || test -n "$verbose_only"
613 then
614 printf 'Bail out! %s\n' \
615 'verbose mode forbidden under TAP harness; try --verbose-log'
616 exit 1
617 fi
618fi
619
Michele Ballabio570f3222007-11-10 15:17:25 +0100620test "${test_description}" != "" ||
621error "Test script did not set test_description."
622
623if test "$help" = "t"
624then
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100625 printf '%s\n' "$test_description"
Michele Ballabio570f3222007-11-10 15:17:25 +0100626 exit 0
627fi
628
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400629exec 5>&1
Jeff King781f76b2011-12-15 01:55:29 -0500630exec 6<&0
SZEDER Gábor4ecae3c2017-03-18 17:13:59 +0100631exec 7>&2
Jeff King452320f2016-10-21 06:48:00 -0400632if test "$verbose_log" = "t"
633then
634 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
635elif test "$verbose" = "t"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700636then
637 exec 4>&2 3>&1
638else
639 exec 4>/dev/null 3>/dev/null
640fi
641
Jeff Kingd88785e2016-05-11 09:44:04 -0400642# Send any "-x" output directly to stderr to avoid polluting tests
643# which capture stderr. We can do this unconditionally since it
644# has no effect if tracing isn't turned on.
645#
646# Note that this sets up the trace fd as soon as we assign the variable, so it
647# must come after the creation of descriptor 4 above. Likewise, we must never
648# unset this, as it has the side effect of closing descriptor 4, which we
649# use to show verbose tests to the user.
650#
651# Note also that we don't need or want to export it. The tracing is local to
652# this shell, and we would not want to influence any shells we exec.
653BASH_XTRACEFD=4
654
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700655test_failure=0
656test_count=0
Junio C Hamano41ac4142008-02-01 01:50:53 -0800657test_fixed=0
658test_broken=0
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +0200659test_success=0
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700660
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000661test_external_has_tap=0
662
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100663die () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200664 code=$?
Johannes Schindelin900721e2019-03-13 13:24:11 +0100665 # This is responsible for running the atexit commands even when a
666 # test script run with '--immediate' fails, or when the user hits
667 # ctrl-C, i.e. when 'test_done' is not invoked at all.
668 test_atexit_handler || code=$?
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200669 if test -n "$GIT_EXIT_OK"
670 then
671 exit $code
672 else
673 echo >&5 "FATAL: Unexpected exit with code $code"
674 exit 1
675 fi
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100676}
677
Johannes Schindelin662f9cf2020-04-11 00:18:12 +0700678file_lineno () {
679 test -z "$GIT_TEST_FRAMEWORK_SELFTEST" && test -n "$BASH" || return 0
Carlo Marcelo Arenas Belón303775a2020-05-07 10:57:06 -0700680 eval '
681 local i
682 for i in ${!BASH_SOURCE[*]}
683 do
684 case $i,"${BASH_SOURCE[$i]##*/}" in
685 0,t[0-9]*.sh) echo "t/${BASH_SOURCE[$i]}:$LINENO: ${1+$1: }"; return;;
686 *,t[0-9]*.sh) echo "t/${BASH_SOURCE[$i]}:${BASH_LINENO[$(($i-1))]}: ${1+$1: }"; return;;
687 esac
688 done
689 '
Johannes Schindelin662f9cf2020-04-11 00:18:12 +0700690}
691
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200692GIT_EXIT_OK=
Markus Heidelberg35641312009-01-20 00:43:26 +0100693trap 'die' EXIT
SZEDER Gáborc5c39f42019-03-13 13:24:09 +0100694# Disable '-x' tracing, because with some shells, notably dash, it
695# prevents running the cleanup commands when a test script run with
696# '--verbose-log -x' is interrupted.
697trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
Pavel Roskin41184272005-08-11 12:00:40 -0400698
Thomas Rast12a29b12012-02-17 11:25:08 +0100699# The user-facing functions are loaded from a separate file so that
700# test_perf subshells can have them too
Junio C Hamano3c8f12c2012-06-24 22:01:35 -0700701. "$TEST_DIRECTORY/test-lib-functions.sh"
Jonathan Nieder05236a52010-10-17 02:36:58 +0800702
Junio C Hamano886856a2005-05-14 00:24:27 -0700703# You are not expected to call test_ok_ and test_failure_ directly, use
Torstein Hegge3fa36662013-10-27 10:56:33 +0100704# the test_expect_* functions instead.
Junio C Hamano886856a2005-05-14 00:24:27 -0700705
706test_ok_ () {
Johannes Schindelin22231902019-01-29 06:19:27 -0800707 if test -n "$write_junit_xml"
708 then
709 write_junit_xml_testcase "$*"
710 fi
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100711 test_success=$(($test_success + 1))
Thomas Rast633fe502013-10-19 23:06:08 +0200712 say_color "" "ok $test_count - $@"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700713}
714
Junio C Hamano886856a2005-05-14 00:24:27 -0700715test_failure_ () {
Johannes Schindelin22231902019-01-29 06:19:27 -0800716 if test -n "$write_junit_xml"
717 then
718 junit_insert="<failure message=\"not ok $test_count -"
719 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
720 junit_insert="$junit_insert $(xml_attr_encode \
Johannes Schindelinaf9912e2019-01-29 06:19:34 -0800721 "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
722 then
723 test-tool path-utils skip-n-bytes \
724 "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
725 else
726 printf '%s\n' "$@" | sed 1d
727 fi)")"
Johannes Schindelin22231902019-01-29 06:19:27 -0800728 junit_insert="$junit_insert</failure>"
Johannes Schindelinaf9912e2019-01-29 06:19:34 -0800729 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
730 then
731 junit_insert="$junit_insert<system-err>$(xml_attr_encode \
732 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
733 fi
Johannes Schindelin22231902019-01-29 06:19:27 -0800734 write_junit_xml_testcase "$1" " $junit_insert"
735 fi
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100736 test_failure=$(($test_failure + 1))
Johannes Schindelin662f9cf2020-04-11 00:18:12 +0700737 say_color error "$(file_lineno error)not ok $test_count - $1"
Junio C Hamanobf0dd8a2005-07-22 19:09:34 -0700738 shift
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100739 printf '%s\n' "$*" | sed -e 's/^/# /'
Johannes Schindelinab7d8542019-10-04 08:09:34 -0700740 test "$immediate" = "" || { finalize_junit_xml; GIT_EXIT_OK=t; exit 1; }
Junio C Hamano886856a2005-05-14 00:24:27 -0700741}
742
Junio C Hamano41ac4142008-02-01 01:50:53 -0800743test_known_broken_ok_ () {
Johannes Schindelin22231902019-01-29 06:19:27 -0800744 if test -n "$write_junit_xml"
745 then
746 write_junit_xml_testcase "$* (breakage fixed)"
747 fi
Junio C Hamano41ac4142008-02-01 01:50:53 -0800748 test_fixed=$(($test_fixed+1))
Thomas Rast633fe502013-10-19 23:06:08 +0200749 say_color error "ok $test_count - $@ # TODO known breakage vanished"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800750}
751
752test_known_broken_failure_ () {
Johannes Schindelin22231902019-01-29 06:19:27 -0800753 if test -n "$write_junit_xml"
754 then
755 write_junit_xml_testcase "$* (known breakage)"
756 fi
Junio C Hamano41ac4142008-02-01 01:50:53 -0800757 test_broken=$(($test_broken+1))
Thomas Rast633fe502013-10-19 23:06:08 +0200758 say_color warn "not ok $test_count - $@ # TODO known breakage"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800759}
Junio C Hamano886856a2005-05-14 00:24:27 -0700760
761test_debug () {
Junio C Hamano8e832eb2005-08-10 22:53:27 -0700762 test "$debug" = "" || eval "$1"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700763}
764
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200765match_pattern_list () {
766 arg="$1"
767 shift
768 test -z "$*" && return 1
769 for pattern_
770 do
771 case "$arg" in
772 $pattern_)
773 return 0
774 esac
775 done
776 return 1
777}
778
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700779match_test_selector_list () {
780 title="$1"
781 shift
782 arg="$1"
783 shift
784 test -z "$1" && return 0
785
786 # Both commas and whitespace are accepted as separators.
787 OLDIFS=$IFS
788 IFS=' ,'
789 set -- $1
790 IFS=$OLDIFS
791
792 # If the first selector is negative we include by default.
793 include=
794 case "$1" in
795 !*) include=t ;;
796 esac
797
798 for selector
799 do
800 orig_selector=$selector
801
802 positive=t
803 case "$selector" in
804 !*)
805 positive=
806 selector=${selector##?}
807 ;;
808 esac
809
810 test -z "$selector" && continue
811
812 case "$selector" in
813 *-*)
814 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
815 then
816 echo "error: $title: invalid non-numeric in range" \
817 "start: '$orig_selector'" >&2
818 exit 1
819 fi
820 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
821 then
822 echo "error: $title: invalid non-numeric in range" \
823 "end: '$orig_selector'" >&2
824 exit 1
825 fi
826 ;;
827 *)
828 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
829 then
830 echo "error: $title: invalid non-numeric in test" \
831 "selector: '$orig_selector'" >&2
832 exit 1
833 fi
834 esac
835
836 # Short cut for "obvious" cases
837 test -z "$include" && test -z "$positive" && continue
838 test -n "$include" && test -n "$positive" && continue
839
840 case "$selector" in
841 -*)
842 if test $arg -le ${selector#-}
843 then
844 include=$positive
845 fi
846 ;;
847 *-)
848 if test $arg -ge ${selector%-}
849 then
850 include=$positive
851 fi
852 ;;
853 *-*)
854 if test ${selector%%-*} -le $arg \
855 && test $arg -le ${selector#*-}
856 then
857 include=$positive
858 fi
859 ;;
860 *)
861 if test $arg -eq $selector
862 then
863 include=$positive
864 fi
865 ;;
866 esac
867 done
868
869 test -n "$include"
870}
871
Thomas Rastff09af32013-06-23 20:12:56 +0200872maybe_teardown_verbose () {
873 test -z "$verbose_only" && return
874 exec 4>/dev/null 3>/dev/null
875 verbose=
876}
877
878last_verbose=t
879maybe_setup_verbose () {
880 test -z "$verbose_only" && return
Thomas Rast26a07302013-10-19 23:06:07 +0200881 if match_pattern_list $test_count $verbose_only
Thomas Rastff09af32013-06-23 20:12:56 +0200882 then
883 exec 4>&2 3>&1
884 # Emit a delimiting blank line when going from
885 # non-verbose to verbose. Within verbose mode the
886 # delimiter is printed by test_expect_*. The choice
887 # of the initial $last_verbose is such that before
888 # test 1, we do not print it.
889 test -z "$last_verbose" && echo >&3 ""
890 verbose=t
891 else
892 exec 4>/dev/null 3>/dev/null
893 verbose=
894 fi
895 last_verbose=$verbose
896}
897
Thomas Rast5dfc3682013-06-23 20:12:57 +0200898maybe_teardown_valgrind () {
899 test -z "$GIT_VALGRIND" && return
900 GIT_VALGRIND_ENABLED=
901}
902
903maybe_setup_valgrind () {
904 test -z "$GIT_VALGRIND" && return
Thomas Rast26a07302013-10-19 23:06:07 +0200905 if test -z "$valgrind_only"
Thomas Rast5dfc3682013-06-23 20:12:57 +0200906 then
907 GIT_VALGRIND_ENABLED=t
908 return
909 fi
910 GIT_VALGRIND_ENABLED=
911 if match_pattern_list $test_count $valgrind_only
912 then
913 GIT_VALGRIND_ENABLED=t
914 fi
915}
916
Johannes Schindelin477dcad2020-03-26 15:35:26 +0000917trace_level_=0
Jeff King9b5fe782015-08-06 01:33:57 -0400918want_trace () {
Jeff Kingf5ba2de2017-12-08 05:47:17 -0500919 test "$trace" = t && {
920 test "$verbose" = t || test "$verbose_log" = t
921 }
Jeff King9b5fe782015-08-06 01:33:57 -0400922}
923
Jeff Kinga136f6d2014-10-10 02:47:27 -0400924# This is a separate function because some tests use
925# "return" to end a test_expect_success block early
926# (and we want to make sure we run any cleanup like
927# "set +x").
928test_eval_inner_ () {
929 # Do not add anything extra (including LF) after '$*'
930 eval "
Johannes Schindelin477dcad2020-03-26 15:35:26 +0000931 want_trace && trace_level_=$(($trace_level_+1)) && set -x
Jeff Kinga136f6d2014-10-10 02:47:27 -0400932 $*"
933}
934
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200935test_eval_ () {
Jeff King90c8a1d2017-12-08 05:47:08 -0500936 # If "-x" tracing is in effect, then we want to avoid polluting stderr
937 # with non-test commands. But once in "set -x" mode, we cannot prevent
Jeff Kinga136f6d2014-10-10 02:47:27 -0400938 # the shell from printing the "set +x" to turn it off (nor the saving
939 # of $? before that). But we can make sure that the output goes to
940 # /dev/null.
941 #
Jeff King90c8a1d2017-12-08 05:47:08 -0500942 # There are a few subtleties here:
943 #
944 # - we have to redirect descriptor 4 in addition to 2, to cover
945 # BASH_XTRACEFD
946 #
947 # - the actual eval has to come before the redirection block (since
948 # it needs to see descriptor 4 to set up its stderr)
949 #
950 # - likewise, any error message we print must be outside the block to
951 # access descriptor 4
952 #
953 # - checking $? has to come immediately after the eval, but it must
954 # be _inside_ the block to avoid polluting the "set -x" output
955 #
956
957 test_eval_inner_ "$@" </dev/null >&3 2>&4
Jeff Kinga136f6d2014-10-10 02:47:27 -0400958 {
Jeff Kinga136f6d2014-10-10 02:47:27 -0400959 test_eval_ret_=$?
Jeff King9b5fe782015-08-06 01:33:57 -0400960 if want_trace
Jeff Kinga136f6d2014-10-10 02:47:27 -0400961 then
Johannes Schindelin477dcad2020-03-26 15:35:26 +0000962 test 1 = $trace_level_ && set +x
963 trace_level_=$(($trace_level_-1))
Jeff Kinga136f6d2014-10-10 02:47:27 -0400964 fi
Jeff King90c8a1d2017-12-08 05:47:08 -0500965 } 2>/dev/null 4>&2
966
967 if test "$test_eval_ret_" != 0 && want_trace
968 then
969 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
970 fi
Jeff Kinga136f6d2014-10-10 02:47:27 -0400971 return $test_eval_ret_
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200972}
973
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400974test_run_ () {
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500975 test_cleanup=:
Junio C Hamanob5867442011-06-27 11:02:22 -0700976 expecting_failure=$2
Jeff Kingbb79af92015-03-20 06:05:48 -0400977
Jeff King92b269f2015-04-22 16:09:57 -0400978 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
Jeff King2a01ef82015-08-06 01:31:47 -0400979 # turn off tracing for this test-eval, as it simply creates
980 # confusing noise in the "-x" output
981 trace_tmp=$trace
982 trace=
Jeff Kingbb79af92015-03-20 06:05:48 -0400983 # 117 is magic because it is unlikely to match the exit
984 # code of other programs
Eric Sunshine878f9882018-07-11 02:46:33 -0400985 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
986 test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
Junio C Hamano99a64e42017-03-22 22:43:18 -0700987 then
SZEDER Gábor165293a2018-11-19 14:13:26 +0100988 BUG "broken &&-chain or run-away HERE-DOC: $1"
Jeff Kingbb79af92015-03-20 06:05:48 -0400989 fi
Jeff King2a01ef82015-08-06 01:31:47 -0400990 trace=$trace_tmp
Jeff Kingbb79af92015-03-20 06:05:48 -0400991 fi
992
Thomas Rasta57397b2013-06-17 11:18:46 +0200993 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200994 test_eval_ "$1"
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500995 eval_ret=$?
Thomas Rasta57397b2013-06-17 11:18:46 +0200996 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -0700997
Jeff Kinga136f6d2014-10-10 02:47:27 -0400998 if test -z "$immediate" || test $eval_ret = 0 ||
999 test -n "$expecting_failure" && test "$test_cleanup" != ":"
Junio C Hamanob5867442011-06-27 11:02:22 -07001000 then
Junio C Hamano1b3185f2012-09-14 20:38:24 -07001001 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +02001002 test_eval_ "$test_cleanup"
Junio C Hamano1b3185f2012-09-14 20:38:24 -07001003 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -07001004 fi
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001005 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
1006 then
Ævar Arnfjörð Bjarmason57e15382010-06-24 17:44:47 +00001007 echo ""
1008 fi
Jonathan Niederaa0bcf92011-08-08 03:15:34 +02001009 return "$eval_ret"
Pavel Roskin4d9d62f2005-08-10 23:56:21 -04001010}
1011
Thomas Rastae753422013-06-18 14:25:59 +02001012test_start_ () {
Johannes Sixt8586f982009-02-05 21:20:56 +01001013 test_count=$(($test_count+1))
Thomas Rastff09af32013-06-23 20:12:56 +02001014 maybe_setup_verbose
Thomas Rast5dfc3682013-06-23 20:12:57 +02001015 maybe_setup_valgrind
Johannes Schindelin22231902019-01-29 06:19:27 -08001016 if test -n "$write_junit_xml"
1017 then
1018 junit_start=$(test-tool date getnanos)
1019 fi
Thomas Rastae753422013-06-18 14:25:59 +02001020}
1021
1022test_finish_ () {
1023 echo >&3 ""
Thomas Rast5dfc3682013-06-23 20:12:57 +02001024 maybe_teardown_valgrind
Thomas Rastff09af32013-06-23 20:12:56 +02001025 maybe_teardown_verbose
Johannes Schindelinaf9912e2019-01-29 06:19:34 -08001026 if test -n "$GIT_TEST_TEE_OFFSET"
1027 then
1028 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
1029 "$GIT_TEST_TEE_OUTPUT_FILE")
1030 fi
Thomas Rastae753422013-06-18 14:25:59 +02001031}
1032
1033test_skip () {
Junio C Hamano04ece592006-12-28 17:58:00 -08001034 to_skip=
Ilya Bobyref2ac682014-04-30 02:50:43 -07001035 skipped_reason=
Thomas Raste6a6ddc2013-06-18 14:25:58 +02001036 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
1037 then
1038 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -07001039 skipped_reason="GIT_SKIP_TESTS"
Thomas Raste6a6ddc2013-06-18 14:25:58 +02001040 fi
SZEDER Gábore0316692019-11-12 13:24:38 +01001041 if test -z "$to_skip" && test -n "$run_list" &&
1042 ! match_test_selector_list '--run' $test_count "$run_list"
1043 then
1044 to_skip=t
1045 skipped_reason="--run"
1046 fi
Jonathan Nieder05236a52010-10-17 02:36:58 +08001047 if test -z "$to_skip" && test -n "$test_prereq" &&
1048 ! test_have_prereq "$test_prereq"
Johannes Sixta7bb3942009-03-01 21:04:46 +01001049 then
1050 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -07001051
Jonathan Nieder07431fc2010-08-24 02:34:10 -05001052 of_prereq=
Jonathan Nieder05236a52010-10-17 02:36:58 +08001053 if test "$missing_prereq" != "$test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -05001054 then
Jonathan Nieder05236a52010-10-17 02:36:58 +08001055 of_prereq=" of $test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -05001056 fi
Ilya Bobyref2ac682014-04-30 02:50:43 -07001057 skipped_reason="missing $missing_prereq${of_prereq}"
1058 fi
Jonathan Nieder07431fc2010-08-24 02:34:10 -05001059
Ilya Bobyref2ac682014-04-30 02:50:43 -07001060 case "$to_skip" in
1061 t)
Johannes Schindelin22231902019-01-29 06:19:27 -08001062 if test -n "$write_junit_xml"
1063 then
1064 message="$(xml_attr_encode "$skipped_reason")"
1065 write_junit_xml_testcase "$1" \
1066 " <skipped message=\"$message\" />"
1067 fi
1068
Thomas Rast633fe502013-10-19 23:06:08 +02001069 say_color skip >&3 "skipping test: $@"
Ilya Bobyref2ac682014-04-30 02:50:43 -07001070 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
Junio C Hamano04ece592006-12-28 17:58:00 -08001071 : true
1072 ;;
1073 *)
1074 false
1075 ;;
1076 esac
1077}
1078
Thomas Rast342e9ef2012-02-17 11:25:09 +01001079# stub; perf-lib overrides it
1080test_at_end_hook_ () {
1081 :
1082}
1083
Johannes Schindelin22231902019-01-29 06:19:27 -08001084write_junit_xml () {
1085 case "$1" in
1086 --truncate)
1087 >"$junit_xml_path"
1088 junit_have_testcase=
1089 shift
1090 ;;
1091 esac
1092 printf '%s\n' "$@" >>"$junit_xml_path"
1093}
1094
1095xml_attr_encode () {
1096 printf '%s\n' "$@" | test-tool xml-encode
1097}
1098
1099write_junit_xml_testcase () {
1100 junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1101 shift
1102 junit_attrs="$junit_attrs classname=\"$this_test\""
1103 junit_attrs="$junit_attrs time=\"$(test-tool \
1104 date getnanos $junit_start)\""
1105 write_junit_xml "$(printf '%s\n' \
1106 " <testcase $junit_attrs>" "$@" " </testcase>")"
1107 junit_have_testcase=t
1108}
1109
Johannes Schindelinab7d8542019-10-04 08:09:34 -07001110finalize_junit_xml () {
1111 if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1112 then
1113 test -n "$junit_have_testcase" || {
1114 junit_start=$(test-tool date getnanos)
1115 write_junit_xml_testcase "all tests skipped"
1116 }
1117
1118 # adjust the overall time
1119 junit_time=$(test-tool date getnanos $junit_suite_start)
Johannes Schindelin076ee3e2020-02-12 11:27:55 +00001120 sed -e "s/\(<testsuite.*\) time=\"[^\"]*\"/\1/" \
1121 -e "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
Johannes Schindelind3507cc2020-03-23 12:44:35 +00001122 -e '/^ *<\/testsuite/d' \
Johannes Schindelinab7d8542019-10-04 08:09:34 -07001123 <"$junit_xml_path" >"$junit_xml_path.new"
1124 mv "$junit_xml_path.new" "$junit_xml_path"
1125
1126 write_junit_xml " </testsuite>" "</testsuites>"
1127 write_junit_xml=
1128 fi
1129}
1130
Johannes Schindelin900721e2019-03-13 13:24:11 +01001131test_atexit_cleanup=:
1132test_atexit_handler () {
1133 # In a succeeding test script 'test_atexit_handler' is invoked
1134 # twice: first from 'test_done', then from 'die' in the trap on
1135 # EXIT.
1136 # This condition and resetting 'test_atexit_cleanup' below makes
1137 # sure that the registered cleanup commands are run only once.
1138 test : != "$test_atexit_cleanup" || return 0
1139
1140 setup_malloc_check
1141 test_eval_ "$test_atexit_cleanup"
1142 test_atexit_cleanup=:
1143 teardown_malloc_check
1144}
1145
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001146test_done () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +02001147 GIT_EXIT_OK=t
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +02001148
Johannes Schindelin900721e2019-03-13 13:24:11 +01001149 # Run the atexit commands _before_ the trash directory is
1150 # removed, so the commands can access pidfiles and socket files.
1151 test_atexit_handler
1152
Johannes Schindelinab7d8542019-10-04 08:09:34 -07001153 finalize_junit_xml
Johannes Schindelin22231902019-01-29 06:19:27 -08001154
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001155 if test -z "$HARNESS_ACTIVE"
1156 then
SZEDER Gábor62c379b2019-01-05 02:08:56 +01001157 mkdir -p "$TEST_RESULTS_DIR"
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +00001158
SZEDER Gábor62c379b2019-01-05 02:08:56 +01001159 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
Mathias Lafeldtc54e6be2011-04-29 14:30:30 +02001160 total $test_count
1161 success $test_success
1162 fixed $test_fixed
1163 broken $test_broken
1164 failed $test_failure
1165
1166 EOF
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +00001167 fi
Junio C Hamano41ac4142008-02-01 01:50:53 -08001168
1169 if test "$test_fixed" != 0
1170 then
Thomas Rast633fe502013-10-19 23:06:08 +02001171 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -08001172 fi
1173 if test "$test_broken" != 0
1174 then
Thomas Rast633fe502013-10-19 23:06:08 +02001175 say_color warn "# still have $test_broken known breakage(s)"
Adam Spiersb73d9a22012-12-16 18:28:15 +00001176 fi
1177 if test "$test_broken" != 0 || test "$test_fixed" != 0
1178 then
1179 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1180 msg="remaining $test_remaining test(s)"
Junio C Hamano11d54b82008-02-03 00:23:02 -08001181 else
Adam Spiersb73d9a22012-12-16 18:28:15 +00001182 test_remaining=$test_count
Junio C Hamano11d54b82008-02-03 00:23:02 -08001183 msg="$test_count test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -08001184 fi
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001185 case "$test_failure" in
Junio C Hamano10b94e22005-12-09 17:32:18 -08001186 0)
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001187 if test $test_external_has_tap -eq 0
1188 then
Adam Spiersb73d9a22012-12-16 18:28:15 +00001189 if test $test_remaining -gt 0
Ramsay Jonesd87bd7c2012-09-01 19:26:21 +01001190 then
Thomas Rast633fe502013-10-19 23:06:08 +02001191 say_color pass "# passed all $msg"
Ramsay Jonesd87bd7c2012-09-01 19:26:21 +01001192 fi
Junio C Hamanoc7018be2017-05-18 11:52:20 +09001193
1194 # Maybe print SKIP message
1195 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1196 case "$test_count" in
1197 0)
1198 say "1..$test_count${skip_all:+ $skip_all}"
1199 ;;
1200 *)
1201 test -z "$skip_all" ||
1202 say_color warn "$skip_all"
1203 say "1..$test_count"
1204 ;;
1205 esac
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +00001206 fi
Johannes Schindelinabc5d372008-08-08 13:08:37 +02001207
Junio C Hamano06478da2017-04-23 17:15:09 -07001208 if test -z "$debug"
Junio C Hamano4d0912a2017-04-24 23:39:47 -07001209 then
Junio C Hamano06478da2017-04-23 17:15:09 -07001210 test -d "$TRASH_DIRECTORY" ||
Junio C Hamano4d0912a2017-04-24 23:39:47 -07001211 error "Tests passed but trash directory already removed before test cleanup; aborting"
Johannes Schindelinabc5d372008-08-08 13:08:37 +02001212
Junio C Hamano06478da2017-04-23 17:15:09 -07001213 cd "$TRASH_DIRECTORY/.." &&
Johannes Schindelin046e90d2019-01-29 06:19:35 -08001214 rm -fr "$TRASH_DIRECTORY" || {
1215 # try again in a bit
1216 sleep 5;
1217 rm -fr "$TRASH_DIRECTORY"
1218 } ||
Junio C Hamano4d0912a2017-04-24 23:39:47 -07001219 error "Tests passed but test cleanup failed; aborting"
Junio C Hamano4d0912a2017-04-24 23:39:47 -07001220 fi
Thomas Rast342e9ef2012-02-17 11:25:09 +01001221 test_at_end_hook_
1222
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001223 exit 0 ;;
1224
1225 *)
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001226 if test $test_external_has_tap -eq 0
1227 then
Thomas Rast633fe502013-10-19 23:06:08 +02001228 say_color error "# failed $test_failure among $msg"
1229 say "1..$test_count"
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +00001230 fi
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +00001231
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001232 exit 1 ;;
1233
1234 esac
1235}
1236
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001237if test -n "$valgrind"
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001238then
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001239 make_symlink () {
1240 test -h "$2" &&
1241 test "$1" = "$(readlink "$2")" || {
1242 # be super paranoid
1243 if mkdir "$2".lock
1244 then
1245 rm -f "$2" &&
1246 ln -s "$1" "$2" &&
1247 rm -r "$2".lock
1248 else
1249 while test -d "$2".lock
1250 do
1251 say "Waiting for lock on $2."
1252 sleep 1
1253 done
1254 fi
1255 }
1256 }
1257
1258 make_valgrind_symlink () {
Jeff King36bfb0e2011-06-17 16:36:32 -04001259 # handle only executables, unless they are shell libraries that
Jonathan Nieder11d62142013-11-25 13:03:52 -08001260 # need to be in the exec-path.
Jeff King36bfb0e2011-06-17 16:36:32 -04001261 test -x "$1" ||
Ævar Arnfjörð Bjarmason2a59a6e2018-08-24 15:20:11 +00001262 test "# " = "$(test_copy_bytes 2 <"$1")" ||
Jeff King36bfb0e2011-06-17 16:36:32 -04001263 return;
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001264
1265 base=$(basename "$1")
René Scharfe28fab7b2016-10-28 00:14:00 +02001266 case "$base" in
1267 test-*)
1268 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1269 ;;
1270 *)
1271 symlink_target="$GIT_BUILD_DIR/$base"
1272 ;;
1273 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001274 # do not override scripts
1275 if test -x "$symlink_target" &&
1276 test ! -d "$symlink_target" &&
Ævar Arnfjörð Bjarmason2a59a6e2018-08-24 15:20:11 +00001277 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001278 then
1279 symlink_target=../valgrind.sh
1280 fi
Johannes Schindelinefd92ff2009-02-04 00:26:08 +01001281 case "$base" in
1282 *.sh|*.perl)
1283 symlink_target=../unprocessed-script
1284 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001285 # create the link, or replace it if it is out of date
1286 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1287 }
1288
Thomas Rast26a07302013-10-19 23:06:07 +02001289 # override all git executables in TEST_DIRECTORY/..
1290 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1291 mkdir -p "$GIT_VALGRIND"/bin
Johannes Schindelin503e2242016-07-11 13:45:08 +02001292 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
Thomas Rast26a07302013-10-19 23:06:07 +02001293 do
1294 make_valgrind_symlink $file
1295 done
1296 # special-case the mergetools loadables
1297 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1298 OLDIFS=$IFS
1299 IFS=:
1300 for path in $PATH
1301 do
1302 ls "$path"/git-* 2> /dev/null |
1303 while read file
Johannes Schindelinefd92ff2009-02-04 00:26:08 +01001304 do
Thomas Rast26a07302013-10-19 23:06:07 +02001305 make_valgrind_symlink "$file"
Johannes Schindelinefd92ff2009-02-04 00:26:08 +01001306 done
Thomas Rast26a07302013-10-19 23:06:07 +02001307 done
1308 IFS=$OLDIFS
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001309 PATH=$GIT_VALGRIND/bin:$PATH
1310 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1311 export GIT_VALGRIND
Thomas Rast952af352013-03-31 10:00:16 +02001312 GIT_VALGRIND_MODE="$valgrind"
1313 export GIT_VALGRIND_MODE
Thomas Rast5dfc3682013-06-23 20:12:57 +02001314 GIT_VALGRIND_ENABLED=t
Thomas Rast26a07302013-10-19 23:06:07 +02001315 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
Thomas Rast5dfc3682013-06-23 20:12:57 +02001316 export GIT_VALGRIND_ENABLED
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001317elif test -n "$GIT_TEST_INSTALLED"
1318then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001319 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1320 error "Cannot run git from $GIT_TEST_INSTALLED."
Johannes Schindelin16df35c2018-11-12 05:48:33 -08001321 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001322 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1323else # normal case, use ../bin-wrappers only unless $with_dashes:
Johannes Schindelindd167a32019-01-29 06:19:37 -08001324 if test -n "$no_bin_wrappers"
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001325 then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001326 with_dashes=t
Johannes Schindelindd167a32019-01-29 06:19:37 -08001327 else
1328 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1329 if ! test -x "$git_bin_dir/git"
1330 then
1331 if test -z "$with_dashes"
1332 then
1333 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1334 fi
1335 with_dashes=t
1336 fi
1337 PATH="$git_bin_dir:$PATH"
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001338 fi
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +00001339 GIT_EXEC_PATH=$GIT_BUILD_DIR
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001340 if test -n "$with_dashes"
1341 then
Johannes Schindelinca7312d2019-01-29 06:19:35 -08001342 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001343 fi
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001344fi
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +00001345GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
Jeff King8bfa6bd2008-02-06 05:11:53 -05001346GIT_CONFIG_NOSYSTEM=1
Jonathan Nieder3c995be2011-03-15 04:05:10 -05001347GIT_ATTR_NOSYSTEM=1
Jonathan Nieder8f323c02011-03-15 04:04:49 -05001348export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
Junio C Hamano49ccb082005-12-07 21:52:28 -08001349
Junio C Hamano5e87eae2010-06-11 09:40:25 -07001350if test -z "$GIT_TEST_CMP"
1351then
1352 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1353 then
1354 GIT_TEST_CMP="$DIFF -c"
1355 else
1356 GIT_TEST_CMP="$DIFF -u"
1357 fi
1358fi
1359
Ævar Arnfjörð Bjarmason20d2a302017-12-10 21:13:33 +00001360GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
Petr Baudis6fcca932006-07-03 23:16:32 +02001361export GITPERLLIB
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +00001362test -d "$GIT_BUILD_DIR"/templates/blt || {
Junio C Hamanoeea42062005-12-10 20:55:32 -08001363 error "You haven't built things yet, have you?"
1364}
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001365
Johannes Schindelind6096152019-01-21 07:12:19 -08001366if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001367then
Nguyễn Thái Ngọc Duy0e496492018-03-24 08:44:31 +01001368 echo >&2 'You need to build test-tool:'
1369 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
Eric Wong56cf9802007-02-24 16:59:52 -08001370 exit 1
1371fi
1372
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001373# Test repository
John Keeping38b074d2013-04-14 17:34:56 +01001374rm -fr "$TRASH_DIRECTORY" || {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +02001375 GIT_EXIT_OK=t
Junio C Hamano8d14ac92008-03-18 21:58:01 -07001376 echo >&5 "FATAL: Cannot prepare test area"
1377 exit 1
1378}
1379
Alex Riesen90cff962011-03-26 19:46:34 +01001380HOME="$TRASH_DIRECTORY"
Junio C Hamano0ea47f92014-09-15 14:59:00 -07001381GNUPGHOME="$HOME/gnupg-home-not-used"
1382export HOME GNUPGHOME
Alex Riesen90cff962011-03-26 19:46:34 +01001383
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001384if test -z "$TEST_NO_CREATE_REPO"
1385then
John Keeping38b074d2013-04-14 17:34:56 +01001386 test_create_repo "$TRASH_DIRECTORY"
Thomas Rast342e9ef2012-02-17 11:25:09 +01001387else
John Keeping38b074d2013-04-14 17:34:56 +01001388 mkdir -p "$TRASH_DIRECTORY"
Thomas Rast342e9ef2012-02-17 11:25:09 +01001389fi
Johannes Schindelin22231902019-01-29 06:19:27 -08001390
Lea Wiemann1bd9c642008-05-31 23:11:21 +02001391# Use -P to resolve symlinks in our working directory so that the cwd
1392# in subprocesses like git equals our $PWD (for pathname comparisons).
John Keeping38b074d2013-04-14 17:34:56 +01001393cd -P "$TRASH_DIRECTORY" || exit 1
Junio C Hamano04ece592006-12-28 17:58:00 -08001394
Johannes Sixtd5d9de12009-02-05 20:59:27 +01001395this_test=${0##*/}
1396this_test=${this_test%%-*}
Thomas Raste6a6ddc2013-06-18 14:25:58 +02001397if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1398then
1399 say_color info >&3 "skipping test $this_test altogether"
1400 skip_all="skip all tests in $this_test"
1401 test_done
1402fi
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001403
Johannes Schindelin22231902019-01-29 06:19:27 -08001404if test -n "$write_junit_xml"
1405then
1406 junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1407 mkdir -p "$junit_xml_dir"
1408 junit_xml_base=${0##*/}
1409 junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1410 junit_attrs="name=\"${junit_xml_base%.sh}\""
1411 junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1412 date +%Y-%m-%dT%H:%M:%S)\""
1413 write_junit_xml --truncate "<testsuites>" " <testsuite $junit_attrs>"
1414 junit_suite_start=$(test-tool date getnanos)
Johannes Schindelinaf9912e2019-01-29 06:19:34 -08001415 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1416 then
1417 GIT_TEST_TEE_OFFSET=0
1418 fi
Johannes Schindelin22231902019-01-29 06:19:27 -08001419fi
1420
brian m. carlson192b5172020-02-22 20:17:31 +00001421# Convenience
1422# A regexp to match 5, 35 and 40 hexdigits
1423_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1424_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1425_x40="$_x35$_x05"
1426
1427test_oid_init
1428
1429ZERO_OID=$(test_oid zero)
1430OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
brian m. carlsona1142962020-05-13 00:53:41 +00001431OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
brian m. carlson192b5172020-02-22 20:17:31 +00001432EMPTY_TREE=$(test_oid empty_tree)
1433EMPTY_BLOB=$(test_oid empty_blob)
1434_z40=$ZERO_OID
1435
Junio C Hamano11f470a2019-02-09 10:25:26 -08001436# Provide an implementation of the 'yes' utility; the upper bound
1437# limit is there to help Windows that cannot stop this loop from
1438# wasting cycles when the downstream stops reading, so do not be
1439# tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1440# limit the output of the yes utility", 2016-02-02)
Brandon Casey86487322009-08-28 17:32:41 -05001441yes () {
1442 if test $# = 0
1443 then
1444 y=y
1445 else
1446 y="$*"
1447 fi
1448
Johannes Schindelin6129c932016-02-02 19:15:53 +01001449 i=0
1450 while test $i -lt 99
Brandon Casey86487322009-08-28 17:32:41 -05001451 do
Johannes Schindelin6129c932016-02-02 19:15:53 +01001452 echo "$y"
1453 i=$(($i+1))
Brandon Casey86487322009-08-28 17:32:41 -05001454 done
1455}
1456
Ævar Arnfjörð Bjarmasonc7400392019-06-21 12:18:12 +02001457# The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1458# thus needs to be set up really early, and set an internal variable
1459# for convenience so the hot test_set_prereq() codepath doesn't need
SZEDER Gábor43a2afe2019-11-22 14:14:36 +01001460# to call "git env--helper" (via test_bool_env). Only do that work
1461# if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
Ævar Arnfjörð Bjarmasonc7400392019-06-21 12:18:12 +02001462GIT_TEST_FAIL_PREREQS_INTERNAL=
1463if test -n "$GIT_TEST_FAIL_PREREQS"
1464then
SZEDER Gábor43a2afe2019-11-22 14:14:36 +01001465 if test_bool_env GIT_TEST_FAIL_PREREQS false
Ævar Arnfjörð Bjarmasonc7400392019-06-21 12:18:12 +02001466 then
1467 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1468 test_set_prereq FAIL_PREREQS
1469 fi
1470else
1471 test_lazy_prereq FAIL_PREREQS '
SZEDER Gábor43a2afe2019-11-22 14:14:36 +01001472 test_bool_env GIT_TEST_FAIL_PREREQS false
Ævar Arnfjörð Bjarmasonc7400392019-06-21 12:18:12 +02001473 '
1474fi
1475
Ed Maste7187c7b2019-11-27 17:15:07 +00001476# Fix some commands on Windows, and other OS-specific things
Johannes Schindelind98b2c52016-07-21 18:02:54 +02001477uname_s=$(uname -s)
1478case $uname_s in
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001479*MINGW*)
1480 # Windows has its own (incompatible) sort and find
1481 sort () {
1482 /usr/bin/sort "$@"
1483 }
1484 find () {
1485 /usr/bin/find "$@"
1486 }
Johannes Sixt41141562009-03-13 23:35:24 +01001487 # git sees Windows-style pwd
1488 pwd () {
1489 builtin pwd -W
1490 }
Johannes Sixtee9fb682009-03-13 22:55:27 +01001491 # no POSIX permissions
Johannes Sixt6fd11062009-03-13 23:00:15 +01001492 # backslashes in pathspec are converted to '/'
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001493 # exec does not inherit the PID
Pat Thoytsa94114a2010-09-12 10:37:24 +01001494 test_set_prereq MINGW
Brice Lambson5f4e02e2014-08-30 23:39:07 +02001495 test_set_prereq NATIVE_CRLF
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001496 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -04001497 test_set_prereq GREP_STRIPS_CR
Johannes Sixt4d715ac2013-10-26 21:17:15 +02001498 GIT_TEST_CMP=mingw_test_cmp
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001499 ;;
1500*CYGWIN*)
1501 test_set_prereq POSIXPERM
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001502 test_set_prereq EXECKEEPSPID
Pete Wyckoffcfa96492013-01-26 22:11:11 -05001503 test_set_prereq CYGWIN
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001504 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -04001505 test_set_prereq GREP_STRIPS_CR
Johannes Sixtee9fb682009-03-13 22:55:27 +01001506 ;;
Ed Maste7187c7b2019-11-27 17:15:07 +00001507FreeBSD)
1508 test_set_prereq REGEX_ILLSEQ
1509 test_set_prereq POSIXPERM
1510 test_set_prereq BSLASHPSPEC
1511 test_set_prereq EXECKEEPSPID
1512 ;;
Johannes Sixtee9fb682009-03-13 22:55:27 +01001513*)
1514 test_set_prereq POSIXPERM
Johannes Sixt6fd11062009-03-13 23:00:15 +01001515 test_set_prereq BSLASHPSPEC
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001516 test_set_prereq EXECKEEPSPID
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001517 ;;
1518esac
Johannes Sixt704a3142009-03-04 22:38:24 +01001519
Zbigniew Jędrzejewski-Szmekb0826872012-04-27 11:25:25 +02001520( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
Jeff King1b19ccd2009-04-03 15:33:59 -04001521test -z "$NO_PERL" && test_set_prereq PERL
Ævar Arnfjörð Bjarmason68c7d272017-05-25 19:45:31 +00001522test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
Johan Herlandd4e1b472009-11-18 02:42:31 +01001523test -z "$NO_PYTHON" && test_set_prereq PYTHON
Ævar Arnfjörð Bjarmason94da9192017-06-01 18:20:56 +00001524test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
Ævar Arnfjörð Bjarmasonce9a2572017-11-23 14:16:57 +00001525test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1526test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
Ævar Arnfjörð Bjarmason5e9637c2011-11-18 00:14:42 +01001527test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
Jeff King1b19ccd2009-04-03 15:33:59 -04001528
Ævar Arnfjörð Bjarmason6cdccfc2018-11-08 21:15:29 +00001529if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
Jonathan Nieder30955222011-02-22 23:41:22 +00001530then
Ævar Arnfjörð Bjarmason6cdccfc2018-11-08 21:15:29 +00001531 GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
Junio C Hamanof88b9cb2019-04-15 13:48:31 +09001532 export GIT_TEST_GETTEXT_POISON
Ævar Arnfjörð Bjarmason6cdccfc2018-11-08 21:15:29 +00001533 unset GIT_TEST_GETTEXT_POISON_ORIG
1534fi
1535
Ævar Arnfjörð Bjarmason1ff750b2019-06-21 12:18:09 +02001536test_lazy_prereq C_LOCALE_OUTPUT '
SZEDER Gábor43a2afe2019-11-22 14:14:36 +01001537 ! test_bool_env GIT_TEST_GETTEXT_POISON false
Ævar Arnfjörð Bjarmason1ff750b2019-06-21 12:18:09 +02001538'
Ævar Arnfjörð Bjarmasonbb946bb2011-02-22 23:41:21 +00001539
Nguyễn Thái Ngọc Duy4592e602018-08-18 16:41:28 +02001540if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1541then
1542 GIT_TEST_CHECK_CACHE_TREE=true
1543 export GIT_TEST_CHECK_CACHE_TREE
1544fi
1545
Adam Spiers20073272013-04-11 03:07:04 +01001546test_lazy_prereq PIPE '
1547 # test whether the filesystem supports FIFOs
Ramsay Jones7b7bea22017-09-17 23:56:00 +01001548 test_have_prereq !MINGW,!CYGWIN &&
1549 rm -f testfifo && mkfifo testfifo
Adam Spiers20073272013-04-11 03:07:04 +01001550'
1551
Junio C Hamano04083f22012-07-26 15:50:45 -07001552test_lazy_prereq SYMLINKS '
1553 # test whether the filesystem supports symbolic links
1554 ln -s x y && test -h y
1555'
Ævar Arnfjörð Bjarmasonc91cfd12010-08-06 22:09:09 +00001556
Jonathan Niederb018c732013-11-25 13:02:16 -08001557test_lazy_prereq FILEMODE '
1558 test "$(git config --bool core.filemode)" = true
1559'
1560
Michael J Gruberac39aa62012-07-26 15:39:53 +02001561test_lazy_prereq CASE_INSENSITIVE_FS '
1562 echo good >CamelCase &&
1563 echo bad >camelcase &&
1564 test "$(cat CamelCase)" != good
1565'
1566
William Chargin6ec63302018-08-06 11:35:08 -07001567test_lazy_prereq FUNNYNAMES '
1568 test_have_prereq !MINGW &&
1569 touch -- \
1570 "FUNNYNAMES tab embedded" \
1571 "FUNNYNAMES \"quote embedded\"" \
1572 "FUNNYNAMES newline
1573embedded" 2>/dev/null &&
1574 rm -- \
1575 "FUNNYNAMES tab embedded" \
1576 "FUNNYNAMES \"quote embedded\"" \
1577 "FUNNYNAMES newline
1578embedded" 2>/dev/null
1579'
1580
Michael J Gruber5b0b5dd2012-07-26 15:39:56 +02001581test_lazy_prereq UTF8_NFD_TO_NFC '
1582 # check whether FS converts nfd unicode to nfc
1583 auml=$(printf "\303\244")
1584 aumlcdiar=$(printf "\141\314\210")
1585 >"$auml" &&
Torsten Bögershausen742ae102018-04-30 08:35:19 +02001586 test -f "$aumlcdiar"
Michael J Gruber5b0b5dd2012-07-26 15:39:56 +02001587'
1588
Jeff King09feffb2012-11-14 16:33:40 -08001589test_lazy_prereq AUTOIDENT '
1590 sane_unset GIT_AUTHOR_NAME &&
1591 sane_unset GIT_AUTHOR_EMAIL &&
1592 git var GIT_AUTHOR_IDENT
1593'
1594
Junio C Hamano6219bb22014-06-09 12:23:30 -07001595test_lazy_prereq EXPENSIVE '
1596 test -n "$GIT_TEST_LONG"
1597'
1598
Ævar Arnfjörð Bjarmason5b1fe6e2018-01-30 21:21:23 +00001599test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1600 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1601'
1602
Junio C Hamanoe1ecd9e2014-06-09 13:54:25 -07001603test_lazy_prereq USR_BIN_TIME '
1604 test -x /usr/bin/time
1605'
1606
Jeff King1767c512015-01-16 04:16:49 -05001607test_lazy_prereq NOT_ROOT '
1608 uid=$(id -u) &&
1609 test "$uid" != 0
1610'
1611
Jonathan Tan63b747c2016-09-09 10:36:28 -07001612test_lazy_prereq JGIT '
Todd Zullingerabd0f282019-05-14 21:36:33 -04001613 jgit --version
Jonathan Tan63b747c2016-09-09 10:36:28 -07001614'
1615
Junio C Hamano719c3da2016-01-19 14:09:37 -08001616# SANITY is about "can you correctly predict what the filesystem would
1617# do by only looking at the permission bits of the files and
1618# directories?" A typical example of !SANITY is running the test
1619# suite as root, where a test may expect "chmod -r file && cat file"
1620# to fail because file is supposed to be unreadable after a successful
1621# chmod. In an environment (i.e. combination of what filesystem is
1622# being used and who is running the tests) that lacks SANITY, you may
1623# be able to delete or create a file when the containing directory
1624# doesn't have write permissions, or access a file even if the
1625# containing directory doesn't have read or execute permissions.
1626
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001627test_lazy_prereq SANITY '
1628 mkdir SANETESTD.1 SANETESTD.2 &&
1629
1630 chmod +w SANETESTD.1 SANETESTD.2 &&
1631 >SANETESTD.1/x 2>SANETESTD.2/x &&
1632 chmod -w SANETESTD.1 &&
Junio C Hamano719c3da2016-01-19 14:09:37 -08001633 chmod -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001634 chmod -rx SANETESTD.2 ||
SZEDER Gábor165293a2018-11-19 14:13:26 +01001635 BUG "cannot prepare SANETESTD"
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001636
Junio C Hamano719c3da2016-01-19 14:09:37 -08001637 ! test -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001638 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1639 status=$?
1640
1641 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1642 rm -rf SANETESTD.1 SANETESTD.2 ||
SZEDER Gábor165293a2018-11-19 14:13:26 +01001643 BUG "cannot clean SANETESTD"
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001644 return $status
1645'
Jeff Kingf838ce52013-03-10 21:31:47 -04001646
Johannes Schindelind98b2c52016-07-21 18:02:54 +02001647test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
Jeff Kingf838ce52013-03-10 21:31:47 -04001648GIT_UNZIP=${GIT_UNZIP:-unzip}
1649test_lazy_prereq UNZIP '
1650 "$GIT_UNZIP" -v
1651 test $? -ne 127
1652'
Jeff King9a308de2015-03-13 00:53:07 -04001653
1654run_with_limited_cmdline () {
1655 (ulimit -s 128 && "$@")
1656}
1657
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001658test_lazy_prereq CMDLINE_LIMIT '
1659 test_have_prereq !MINGW,!CYGWIN &&
1660 run_with_limited_cmdline true
1661'
Jeff King6b9c38e2016-07-11 19:54:18 -04001662
Michael J Gruber4db464f2017-09-07 16:02:20 +02001663run_with_limited_stack () {
1664 (ulimit -s 128 && "$@")
1665}
1666
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001667test_lazy_prereq ULIMIT_STACK_SIZE '
1668 test_have_prereq !MINGW,!CYGWIN &&
1669 run_with_limited_stack true
1670'
Michael J Gruber4db464f2017-09-07 16:02:20 +02001671
Taylor Blaub30fdb42020-04-23 15:41:06 -06001672run_with_limited_open_files () {
1673 (ulimit -n 32 && "$@")
1674}
1675
1676test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1677 test_have_prereq !MINGW,!CYGWIN &&
1678 run_with_limited_open_files true
1679'
1680
Jeff King6b9c38e2016-07-11 19:54:18 -04001681build_option () {
1682 git version --build-options |
1683 sed -ne "s/^$1: //p"
1684}
1685
1686test_lazy_prereq LONG_IS_64BIT '
1687 test 8 -le "$(build_option sizeof-long)"
1688'
Johannes Schindelina07fb052017-04-20 22:52:13 +02001689
Nguyễn Thái Ngọc Duya801a7c2018-03-24 08:44:36 +01001690test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1691test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
Jeff Kinge9184b02018-04-03 10:01:57 -04001692
1693test_lazy_prereq CURL '
1694 curl --version
1695'
brian m. carlsond16ab632018-05-13 02:24:11 +00001696
1697# SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1698# which will not work with other hash algorithms and tests that work but don't
1699# test anything meaningful (e.g. special values which cause short collisions).
1700test_lazy_prereq SHA1 '
1701 test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1702'
Johannes Schindelin11aad462018-10-31 13:02:02 -07001703
1704test_lazy_prereq REBASE_P '
1705 test -z "$GIT_TEST_SKIP_REBASE_P"
1706'